#[derive(PartialEq, Eq)]
pub enum Play {
    Rock,
    Paper,
    Scissors,
}

enum ResultPlay {
    Win,
    Draw,
    Loss,
}

impl Into<char> for Play {
    fn into(self) -> char {
        match self {
            Play::Rock => 'X',
            Play::Paper => 'Y',
            Play::Scissors => 'Z',
        }
    }
}

impl Into<i32> for Play {
    fn into(self) -> i32 {
        match self {
            Play::Rock => 1,
            Play::Paper => 2,
            Play::Scissors => 3,
        }
    }
}

impl From<char> for Play {
    fn from(letter: char) -> Self {
        match letter {
            'A' => Play::Rock,
            'B' => Play::Paper,
            'C' => Play::Scissors,
            'X' => Play::Rock,
            'Y' => Play::Paper,
            'Z' => Play::Scissors,
            _ => panic!("Only A, B, C, X, Y or Z letters are available."),
        }
    }
}

impl Into<i32> for ResultPlay {
    fn into(self) -> i32 {
        match self {
            ResultPlay::Win => 6,
            ResultPlay::Draw => 3,
            ResultPlay::Loss => 0,
        }
    }
}

pub fn winning(play: Play) -> char {
    match play {
        Play::Rock => Play::Paper.into(),
        Play::Paper => Play::Scissors.into(),
        Play::Scissors => Play::Rock.into(),
    }
}
